/* Keep these headers */
#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>
#include <ti84pce.h>

/* Standard headers - it's recommended to leave them included */
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/* Your code here */
void decompRLE(uint8_t* data_out, uint8_t* data_in, uint8_t data_bits, uint8_t** pptr_in, uint8_t** pptr_out, uint8_t omask, uint8_t searchval, uint8_t replval)
{
    uint8_t n=0, colid=0;
    uint8_t r=1<<data_bits;
    uint8_t subst=(searchval!=replval)?1:0;
    while (*data_in)
    {
        n = *data_in >> data_bits;
        colid = *data_in % r;
        memset(data_out, (subst && colid==searchval) ? replval : colid|omask, n);
        data_out += n;
        data_in++;
    }
    if(pptr_in) *pptr_in=data_in+1;
    if(pptr_out) *pptr_out=data_out;
}