/* Keep these headers */
#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>
#include <ti84pce.h>

/* Standard headers - it's recommended to leave them included */
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/* Your code here */

char textbuffer[5]   = {0};

void nopwait(uint16_t n)
{
    uint16_t j;
    for (j=0; j<n; j++) asm("nop"); // small delay
}

/* reverse string s in place */
void reverse(char* s)
{
    uint16_t i, j;
    char c;

    for (i = 0, j = strlen(s)-1; i<j; i++, j--) {
        c = s[i];
        s[i] = s[j];
        s[j] = c;
    }
}

// Unsigned int to string (s), which also returns the pointer to the string
char* uitoa(uint24_t n, uint8_t zeropad_len)
{
    uint24_t i = 0;

    do {       /* generate digits in reverse order */
        textbuffer[i++] = n % 10 + '0';   /* get next digit */
    } while ((n /= 10) > 0);     /* delete it */

    for(; i<zeropad_len; i++)
        textbuffer[i] = '0';

    textbuffer[i] = '\0';

    reverse(textbuffer);

    return textbuffer;
}

void cleanUp()
{
    _OS(
        asm("CALL _DelRes");
        asm("CALL _ClrTxtShd");
        asm("CALL _ClrScrn");
        asm("SET  graphDraw,(iy+graphFlags)");
        asm("CALL _HomeUp");
        asm("CALL _DrawStatusBar");
        asm("CALL _RunIndicOn");
        asm("ei");
    );
}
